loc_E7B8:  ;Spring Object   
    moveq   #0, d0
    move.b  routine(A0), d0
    move.w  Obj41_Index(pc, d0), d1
    jsr     Obj41_Index(pc, d1)
    tst.w   (Two_player_mode).w
    beq.s   loc_E7D0
    bra     DisplaySprite       ; loc_D3C2
loc_E7D0:
    move.w  x_pos(A0), d0
    andi.w  #$FF80, d0
    sub.w   (Camera_X_pos_coarse).w, d0
    cmpi.w  #$280, d0
    bhi     DeleteObject        ; loc_D3B4
    bra     DisplaySprite       ; loc_D3C2
;=============================================================================== 	
Obj41_Index:
    dc.w    Obj41_Main-Obj41_Index
    dc.w    Obj41_Up-Obj41_Index
    dc.w    Obj41_LR-Obj41_Index
    dc.w    Obj41_Down-Obj41_Index
    dc.w    Obj41_Diag-Obj41_Index
    dc.w    Obj41_DiagDown-Obj41_Index
;=============================================================================== 	
Obj41_Main:
    addq.b  #2, routine(A0) ; This indicates that this is the main object Subtype. The parent.
    move.l  #Spring_Mappings, mappings(A0) ; SpringRest  ;Loads the Spring Mappings
    move.w  #$45C, $2(A0)	;VRAM location for the Vertitcal Spring
    ori.b   #4, $1(A0)
    move.b  #$10, width_pixels(A0) ; This indicates how many pixels of the object is interactable.
    move.b  #4, priority(A0)
    move.b  subtype(A0), d0
    lsr.w   #3, d0
    andi.w  #$E, d0
    move.w  Obj41_Init_Index(pc, d0), d0
    jmp     Obj41_Init_Index(pc, d0)
;=============================================================================== 	
Obj41_Init_Index:
    dc.w    SpringPower_Check-Obj41_Init_Index
    dc.w    SpringLR_Init-Obj41_Init_Index
    dc.w    SpringDown_Init-Obj41_Init_Index
    dc.w    SpringDiag_Init-Obj41_Init_Index
    dc.w    SpringDiagDown_Init-Obj41_Init_Index       
;=============================================================================== 	
SpringLR_Init:
    move.b  #4, routine(A0) ;This indicates which Subtype, in this case, the fourth.
    move.b  #2, anim(A0)
    move.b  #3, mapping_frame(A0)
    move.w  #$470, $2(A0) ;VRAM location for the Horizontal Spring
    move.b  #8, width_pixels(A0) ;This indicates how many pixels of the object is interactable.
    bra.s   SpringPower_Check	
;===============================================================================	
SpringDown_Init:        
    move.b  #6, routine(A0)	;This indicates which Subtype, in this case, the sixth.
    move.b  #6, mapping_frame(A0)
    bset    #1, status(A0)
    bra.s   SpringPower_Check
;===============================================================================	
SpringDiag_Init:        
    move.b  #8, routine(A0)
    move.b  #4, anim(A0)
    move.b  #7, mapping_frame(A0)
    move.w  #$43C, $2(A0)  ;VRAM location for the Diagonal Spring        
    bra.s   SpringPower_Check
;===============================================================================	
SpringDiagDown_Init:        
    move.b  #$A, routine(A0)
    move.b  #4, anim(A0)
    move.b  #$A, mapping_frame(A0)
    move.w  #$43C, $2(A0)	;VRAM location for the Down facing Diagonal Spring 
    bset    #1, status(A0)
;===============================================================================	
SpringPower_Check:
    move.b  subtype(A0), d0	;check the Subtype
    andi.w  #$2, d0			;
    move.w  SpringPower(pc, d0), $30(A0)
    btst    #1, d0
    beq.s   MakeSpring_2P
    bset    #5, $2(A0)
    move.l  #SpringGo, mappings(A0)	
;===============================================================================		
MakeSpring_2P:
    bsr     Adjust2PArtPointer     ; loc_DC30
    rts
; ===========================================================================		
SpringPower:
   	dc.w $F000	; This indicates how powerful Red Springs are.
	dc.w $F600  ; This indicates how powerful Yellow Springs are. 	
; ===========================================================================	
Obj41_Up:
    move.w  #$1B, d1 ; This indicates how far the sprite's border goes.
    move.w  #$8, d2
    move.w  #$10, d3
    move.w  x_pos(A0), d4
    lea     (MainCharacter).w, a1
    moveq   #3, d6
    movem.l d1-d4, -(a7)
    bsr     loc_F510
    btst    #3, status(A0)
    beq.s   loc_E8F4
    bsr.s   loc_E918
loc_E8F4:
    movem.l (a7)+, d1-d4
    lea     (Sidekick).w, a1
    moveq   #4, d6
    bsr     loc_F510
    btst    #4, status(A0)
    beq.s   loc_E90C
    bsr.s   loc_E918
loc_E90C:
    lea     (loc_EF36), a1
    bra     AnimateSprite       ; loc_D412
    rts
loc_E918:
    move.w  #$100, anim(A0)
    addq.w  #8,  y_pos(a1)
    move.w  $30(A0), y_vel(a1)
    bset    #1, status(a1)
    bclr    #3, status(a1)
    move.b  #$10, anim(a1)
    move.b  #2, routine(a1)
    move.b  subtype(A0), d0
    bpl.s   loc_E94C
    move.w  #$00, x_vel(a1)
loc_E94C:
    btst    #0, d0
    beq.s   loc_E98C
    move.w  #$1, inertia(a1)
    move.b  #1, flip_angle(a1)
    move.b  #0, anim(a1)
    move.b  #0, $2C(a1)
    move.b  #4, $2D(a1)
    btst    #1, d0
    bne.s   loc_E97C
    move.b  #1, $2C(a1)
loc_E97C:
    btst    #0, status(a1)
    beq.s   loc_E98C
    neg.b   flip_angle(a1)
    neg.w   inertia(a1)
loc_E98C:
    andi.b  #$C, d0
    cmpi.b  #4, d0
    bne.s   loc_E9A2
    move.b  #$C, $3E(a1)
    move.b  #$D, $3F(a1)
loc_E9A2:
    cmpi.b  #8, d0
    bne.s   loc_E9B4
    move.b  #$E, $3E(a1)
    move.b  #$F, $3F(a1)
loc_E9B4:
    move.w  #$CC, d0
    jmp     (Play_Sfx)          ; loc_14C6    
; ===========================================================================
	
Obj41_LR:
    move.w  #$13, d1
    move.w  #$E, d2
    move.w  #$F, d3
    move.w  x_pos(A0), d4
    lea     (MainCharacter).w, a1
    moveq   #3, d6
    movem.l d1-d4, -(a7)
    bsr     loc_F510
    btst    #5, status(A0)
    beq.s   loc_E9FE
    move.b  status(A0), d1
    move.w  x_pos(A0), d0
    sub.w   x_pos(a1), d0
    bcs.s   loc_E9F6
    eori.b  #1, d1
loc_E9F6:
    andi.b  #1, d1
    bne.s   loc_E9FE
    bsr.s   loc_EA3E
loc_E9FE:
    movem.l (a7)+, d1-d4
    lea     (Sidekick).w, a1
    moveq   #4, d6
    bsr     loc_F510
    btst    #6, status(A0)
    beq.s   loc_EA2E
    move.b  status(A0), d1
    move.w  x_pos(A0), d0
    sub.w   x_pos(a1), d0
    bcs.s   loc_EA26
    eori.b  #1, d1
loc_EA26:
    andi.b  #1, d1
    bne.s   loc_EA2E
    bsr.s   loc_EA3E
loc_EA2E:
    bsr     loc_EB16
    lea     (loc_EF36), a1
    bra     AnimateSprite       ; loc_D412
    rts
loc_EA3E:
    move.w  #$300, anim(A0)
    move.w  $30(A0), x_vel(a1)
    addq.w  #8,  x_pos(a1)
    bset    #0, status(a1)
    btst    #0, status(A0)
    bne.s   loc_EA6C
    bclr    #0, status(a1)
    subi.w  #$10, x_pos(a1)
    neg.w   x_vel(a1)
loc_EA6C:
    move.w  #$F, $2E(a1)
    move.w  x_vel(a1), inertia(a1)
    btst    #2, status(a1)
    bne.s   loc_EA86
    move.b  #0, anim(a1)
loc_EA86:
    move.b  subtype(A0), d0
    bpl.s   loc_EA92
    move.w  #$00, y_vel(a1)
loc_EA92:
    btst    #0, d0
    beq.s   loc_EAD2
    move.w  #$1, inertia(a1)
    move.b  #1, flip_angle(a1)
    move.b  #0, anim(a1)
    move.b  #1, $2C(a1)
    move.b  #8, $2D(a1)
    btst    #1, d0
    bne.s   loc_EAC2
    move.b  #3, $2C(a1)
loc_EAC2:
    btst    #0, status(a1)
    beq.s   loc_EAD2
    neg.b   flip_angle(a1)
    neg.w   inertia(a1)
loc_EAD2:
    andi.b  #$C, d0
    cmpi.b  #4, d0
    bne.s   loc_EAE8
    move.b  #$C, $3E(a1)
    move.b  #$D, $3F(a1)
loc_EAE8:
    cmpi.b  #8, d0
    bne.s   loc_EAFA
    move.b  #$E, $3E(a1)   
    move.b  #$F, $3F(a1)
loc_EAFA:
    bclr    #5, status(A0)
    bclr    #6, status(A0)
    bclr    #5, status(a1)
    move.w  #$CC, d0
    jmp     (Play_Sfx)          ; loc_14C6  
loc_EB16:
    cmpi.b  #3, anim(A0)
    beq     loc_EBCE
    move.w  x_pos(A0), d0
    move.w  d0, d1
    addi.w  #$28, d1
    btst    #0, status(A0)
    beq.s   loc_EB38
    move.w  d0, d1
    subi.w  #$28, d0
loc_EB38:
    move.w  y_pos(A0), d2
    move.w  d2, d3
    subi.w  #$18, d2
    addi.w  #$18, d3
    lea     (MainCharacter).w, a1
    btst    #1, status(a1)
    bne.s   loc_EB8C
    move.w  inertia(a1), d4
    btst    #0, status(A0)
    beq.s   loc_EB60
    neg.w   d4
loc_EB60:
    tst.w   d4
    bmi.s   loc_EB8C
    move.w  x_pos(a1), d4
    cmp.w   d0, d4
    bcs     loc_EB8C
    cmp.w   d1, d4
    bcc     loc_EB8C
    move.w  y_pos(a1), d4
    cmp.w   d2, d4
    bcs     loc_EB8C
    cmp.w   d3, d4
    bcc     loc_EB8C
    move.w  d0, -(a7)
    bsr     loc_EA3E
    move.w  (a7)+, d0
loc_EB8C:
    lea     (Sidekick).w, a1
    btst    #1, status(a1)
    bne.s   loc_EBCE
    move.w  inertia(a1), d4
    btst    #0, status(A0)
    beq.s   loc_EBA6
    neg.w   d4
loc_EBA6:
    tst.w   d4
    bmi.s   loc_EBCE
    move.w  x_pos(a1), d4
    cmp.w   d0, d4
    bcs     loc_EBCE
    cmp.w   d1, d4
    bcc     loc_EBCE
    move.w  y_pos(a1), d4
    cmp.w   d2, d4
    bcs     loc_EBCE
    cmp.w   d3, d4
    bcc     loc_EBCE
    bsr     loc_EA3E
loc_EBCE:
    rts    
	
;=============================================================================== 	
Obj41_Down:
    move.w  #$1B, d1
    move.w  #$8, d2
    move.w  #$10, d3
    move.w  x_pos(A0), d4
    lea     (MainCharacter).w, a1
    moveq   #3, d6
    movem.l d1-d4, -(a7)
    bsr     loc_F510
    cmpi.w  #$FFFE, d4
    bne.s   loc_EBF6
    bsr.s   loc_EC18
loc_EBF6:
    movem.l (a7)+, d1-d4
    lea     (Sidekick).w, a1
    moveq   #4, d6
    bsr     loc_F510
    cmpi.w  #$FFFE, d4
    bne.s   loc_EC0C
    bsr.s   loc_EC18
loc_EC0C:
    lea     (loc_EF36), a1
    bra     AnimateSprite       ; loc_D412
    rts
loc_EC18:
    move.w  #$100, anim(A0)
    subq.w  #8, y_pos(a1)
    move.w  $30(A0), y_vel(a1)
    neg.w   y_vel(a1)
    move.b  subtype(A0), d0
    bpl.s   loc_EC38
    move.w  #$00, x_vel(a1)
loc_EC38:
    btst    #0, d0
    beq.s   loc_EC78
    move.w  #$1, inertia(a1)
    move.b  #1, flip_angle(a1)
    move.b  #0, anim(a1)
    move.b  #0, $2C(a1)
    move.b  #4, $2D(a1)
    btst    #1, d0
    bne.s   loc_EC68
    move.b  #1, $2C(a1)
loc_EC68:
    btst    #0, status(a1)
    beq.s   loc_EC78
    neg.b   flip_angle(a1)
    neg.w   inertia(a1)
loc_EC78:
    andi.b  #$C, d0
    cmpi.b  #4, d0
    bne.s   loc_EC8E
    move.b  #$C, $3E(a1)
    move.b  #$D, $3F(a1)
loc_EC8E:
    cmpi.b  #8, d0
    bne.s   loc_ECA0
    move.b  #$E, $3E(a1)
    move.b  #$F, $3F(a1)
loc_ECA0:
    bset    #1, status(a1)
    bclr    #3, status(a1)
    move.b  #2, routine(a1)
    move.w  #$CC, d0
    jmp     (Play_Sfx)          ; loc_14C6   
;=============================================================================== 
	
Obj41_Diag:
    move.w  #$1B, d1
    move.w  #$10, d2
    move.w  x_pos(A0), d4
    lea     DiagRightFaceCollision(pc), a2
    lea     (MainCharacter).w, a1
    moveq   #3, d6
    movem.l d1-d4, -(a7)
    bsr     loc_F562
    btst    #3, status(A0)
    beq.s   loc_ECE4
    bsr.s   loc_ED08
loc_ECE4:
    movem.l (a7)+, d1-d4
    lea     (Sidekick).w, a1
    moveq   #4, d6
    bsr     loc_F562
    btst    #4, status(A0)
    beq.s   loc_ECFC
    bsr.s   loc_ED08
loc_ECFC:
    lea     (loc_EF36), a1
    bra     AnimateSprite       ; loc_D412
    rts
loc_ED08:
    btst    #0, status(A0)
    bne.s   loc_ED1E           
    move.w  x_pos(A0), d0
    subq.w  #4, d0
    cmp.w   x_pos(a1), d0
    bcs.s   loc_ED2C
    rts
loc_ED1E:
    move.w  x_pos(A0), d0
    addq.w  #4, d0
    cmp.w   x_pos(a1), d0
    bcc.s   loc_ED2C
    rts
loc_ED2C:
    move.w  #$500, anim(A0)
    move.w  $30(A0), y_vel(a1)
    move.w  $30(A0), x_vel(a1)
    addq.w  #6, y_pos(a1)
    addq.w  #6, x_pos(a1)
    bset    #0, status(a1)
    btst    #0, status(A0)
    bne.s   loc_ED64
    bclr    #0, status(a1)
    subi.w  #$C, x_pos(a1)
    neg.w   x_vel(a1)
loc_ED64:
    bset    #1, status(a1)
    bclr    #3, status(a1)
    move.b  #$10, anim(a1)
    move.b  #2, routine(a1)
    move.b  subtype(A0), d0
    btst    #0, d0
    beq.s   loc_EDC0
    move.w  #$1, inertia(a1)
    move.b  #1, flip_angle(a1)
    move.b  #0, anim(a1)
    move.b  #1, $2C(a1)
    move.b  #8, $2D(a1)
    btst    #1, d0
    bne.s   loc_EDB0
    move.b  #3, $2C(a1)
loc_EDB0:
    btst    #0, status(a1)
    beq.s   loc_EDC0
    neg.b   flip_angle(a1)
    neg.w   inertia(a1)
loc_EDC0:
    andi.b  #$C, d0
    cmpi.b  #4, d0
    bne.s   loc_EDD6
    move.b  #$C, $3E(a1)
    move.b  #$D, $3F(a1)
loc_EDD6:
    cmpi.b  #8, d0
    bne.s   loc_EDE8
    move.b  #$E, $3E(a1)
    move.b  #$F, $3F(a1)
loc_EDE8:
    move.w  #$CC, d0
    jmp     (Play_Sfx)          ; loc_14C6     
;=============================================================================== 	
Obj41_DiagDown:
    move.w  #$1B, d1
    move.w  #$10, d2
    move.w  x_pos(A0), d4
    lea     DiagLeftFaceCollision(pc), a2
    lea     (MainCharacter).w, a1
    moveq   #3, d6
    movem.l d1-d4, -(a7)
    bsr     loc_F562
    cmpi.w  #$FFFE, d4
    bne.s   loc_EE18
    bsr.s   loc_EE3A
loc_EE18:
    movem.l (a7)+, d1-d4
    lea     (Sidekick).w, a1
    moveq   #4, d6
    bsr     loc_F562
    cmpi.w  #$FFFE, d4
    bne.s   loc_EE2E
    bsr.s   loc_EE3A
loc_EE2E:
    lea     (loc_EF36), a1
    bra     AnimateSprite       ; loc_D412
    rts
loc_EE3A:
    move.w  #$500, anim(A0)
    move.w  $30(A0), y_vel(a1)
    neg.w   y_vel(a1)
    move.w  $30(A0), x_vel(a1)
    subq.w  #6, y_pos(a1)
    addq.w  #6, x_pos(a1)
    bset    #0, status(a1)
    btst    #0, status(A0)
    bne.s   loc_EE76
    bclr    #0, status(a1)
    subi.w  #$C, x_pos(a1)
    neg.w   x_vel(a1)
loc_EE76:
    bset    #1, status(a1)
    bclr    #3, status(a1)
    move.b  #2, routine(a1)
    move.b  subtype(A0), d0
    btst    #0, d0
    beq.s   loc_EECC
    move.w  #$1, inertia(a1)
    move.b  #1, flip_angle(a1)
    move.b  #0, anim(a1)
    move.b  #1, $2C(a1)
    move.b  #8, $2D(a1)
    btst    #1, d0 
    bne.s   loc_EEBC
    move.b  #3, $2C(a1)
loc_EEBC:
    btst    #0, status(a1)
    beq.s   loc_EECC
    neg.b   flip_angle(a1)
    neg.w   inertia(a1)
loc_EECC:
    andi.b  #$C, d0
    cmpi.b  #4, d0
    bne.s   loc_EEE2
    move.b  #$C, $3E(a1)
    move.b  #$D, $3F(a1)
loc_EEE2:
    cmpi.b  #8, d0
    bne.s   loc_EEF4
    move.b  #$E, $3E(a1)
    move.b  #$F, $3F(a1)
loc_EEF4:
    move.w  #$CC, d0
    jmp     (Play_Sfx)          ; loc_14C6 
;=============================================================================== 	
DiagRightFaceCollision:   
    dc.b    $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $E, $C, $A, $8
    dc.b    $6, $4, $2, $00, $FE, $FC, $FC, $FC, $FC, $FC, $FC, $FC
DiagLeftFaceCollision:        
    dc.b    $F4, $F0, $F0, $F0, $F0, $F0, $F0, $F0, $F0, $F0, $F0, $F0, $F2, $F4, $F6, $F8
    dc.b    $FA, $FC, $FE, $00, $2, $4, $4, $4, $4, $4, $4, $4
loc_EF36:
    dc.b    $00, $C, $00, $F, $00, $1B, $00, $1E, $00, $2A, $00, $2D, $F, $00, $FF, $00
    dc.b    $1, $00, $00, $2, $2, $2, $2, $2, $2, $FD, $00, $F, $3, $FF, $00, $4
    dc.b    $3, $3, $5, $5, $5, $5, $5, $5, $FD, $2, $F, $7, $FF, $00, $8, $7
    dc.b    $7, $9, $9, $9, $9, $9, $9, $FD, $4, $00
;=============================================================================== 	
Spring_Mappings:
SpringRest:
    dc.w    loc_EF9C-SpringRest
    dc.w    loc_EFAE-SpringRest
    dc.w    loc_EFB8-SpringRest
    dc.w    loc_EFCA-SpringRest
    dc.w    loc_EFDC-SpringRest
    dc.w    loc_EFE6-SpringRest
    dc.w    loc_EFF8-SpringRest
    dc.w    loc_F00A-SpringRest
    dc.w    loc_F02C-SpringRest
    dc.w    loc_F046-SpringRest
    dc.w    loc_F068-SpringRest
SpringGo:
    dc.w    loc_EF9C-SpringGo
    dc.w    loc_EFAE-SpringGo
    dc.w    loc_EFB8-SpringGo
    dc.w    loc_EFCA-SpringGo
    dc.w    loc_EFDC-SpringGo
    dc.w    loc_EFE6-SpringGo
    dc.w    loc_EFF8-SpringGo
    dc.w    loc_F08A-SpringGo
    dc.w    loc_F0AC-SpringGo
    dc.w    loc_F0C6-SpringGo
    dc.w    loc_F0E8-SpringGo         
loc_EF9C:
    dc.w    $2
    dc.l    $F00D0000, $0000FFF0, $50008, $4FFF8
loc_EFAE:
    dc.w    $1
    dc.l    $F80D0000, $0000FFF0
loc_EFB8:
    dc.w    $2
    dc.l    $E00D0000, $0000FFF0, $F007000C, $6FFF8
loc_EFCA:
    dc.w    $2
    dc.l    $F0030000, $00000000, $F8010004, $2FFF8
loc_EFDC:
    dc.w    $1
    dc.l    $F0030000, $0000FFF8
loc_EFE6:
    dc.w    $2
    dc.l    $F0030000, $00000010, $F8090006, $3FFF8
loc_EFF8:
    dc.w    $2
    dc.l    $D1000, $1000FFF0, $F0051008, $1004FFF8
loc_F00A:
    dc.w    $4
    dc.l    $F00D0000, $0000FFF0, $50008, $40000
    dc.l    $FB05000C, $6FFF6, $5201C, $200EFFF0
loc_F02C:
    dc.w    $3
    dc.l    $F60D0000, $0000FFEA, $6050008, $4FFFA
    dc.l    $5201C, $200EFFF0
loc_F046:
    dc.w    $4
    dc.l    $E60D0000, $0000FFFB, $F6050008, $4000B
    dc.l    $F30B0010, $8FFF6, $5201C, $200EFFF0
loc_F068:
    dc.w    $4
    dc.l    $D1000, $1000FFF0, $F0051008, $10040000
    dc.l    $F505100C, $1006FFF6, $F005301C, $300EFFF0  
loc_F08A:
    dc.w    $4
    dc.l    $F00D0000, $0000FFF0, $50008, $40000
    dc.l    $FB05000C, $6FFF6, $5001C, $EFFF0
loc_F0AC:
    dc.w    $3
    dc.l    $F60D0000, $0000FFEA, $6050008, $4FFFA
    dc.l    $5001C, $EFFF0
loc_F0C6:
    dc.w    $4
    dc.l    $E60D0000, $0000FFFB, $F6050008, $4000B
    dc.l    $F30B0010, $8FFF6, $5001C, $EFFF0
loc_F0E8:
    dc.w    $4
    dc.l    $D1000, $1000FFF0, $F0051008, $10040000
    dc.l    $F505100C, $1006FFF6, $F005101C, $100EFFF0   
